# all files / Github/bpmn-js/lib/ Viewer.js

92.57% Statements 137/148
84.38% Branches 54/64
93.33% Functions 28/30
92.57% Lines 137/148

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    254
    255
    256
    257
    258
    259
    260
    261
    262
    263
    264
    265
    266
    267
    268
    269
    270
    271
    272
    273
    274
    275
    276
    277
    278
    279
    280
    281
    282
    283
    284
    285
    286
    287
    288
    289
    290
    291
    292
    293
    294
    295
    296
    297
    298
    299
    300
    301
    302
    303
    304
    305
    306
    307
    308
    309
    310
    311
    312
    313
    314
    315
    316
    317
    318
    319
    320
    321
    322
    323
    324
    325
    326
    327
    328
    329
    330
    331
    332
    333
    334
    335
    336
    337
    338
    339
    340
    341
    342
    343
    344
    345
    346
    347
    348
    349
    350
    351
    352
    353
    354
    355
    356
    357
    358
    359
    360
    361
    362
    363
    364
    365
    366
    367
    368
    369
    370
    371
    372
    373
    374
    375
    376
    377
    378
    379
    380
    381
    382
    383
    384
    385
    386
    387
    388
    389
    390
    391
    392
    393
    394
    395
    396
    397
    398
    399
    400
    401
    402
    403
    404
    405
    406
    407
    408
    409
    410
    411
    412
    413
    414
    415
    416
    417
    418
    419
    420
    421
    422
    423
    424
    425
    426
    427
    428
    429
    430
    431
    432
    433
    434
    435
    436
    437
    438
    439
    440
    441
    442
    443
    444
    445
    446
    447
    448
    449
    450
    451
    452
    453
    454
    455
    456
    457
    458
    459
    460
    461
    462
    463
    464
    465
    466
    467
    468
    469
    470
    471
    472
    473
    474
    475
    476
    477
    478
    479
    480
    481
    482
    483
    484
    485
    486
    487
    488
    489
    490
    491
    492
    493
    494
    495
    496
    497
    498
    499
    500
    501
    502
    503
    504
    505
    506
    507
    508
    509
    510
    511
    512
    513
    514
    515
    516
    517
    518
    519
    520
    521
    522
    523
    524
    525
    526
    527
    528
    529
    530
    531
    532
    533
    534
    535
    536
    537
    538
    539
    540
    541
    542
    543
    544
    545
    546
    547
    548
    549
    550
    551
    552
    553
    554
    555
    556
    557
    558
    559
    560
    561
    562
    563
    564
    565
    566
    567
    568
    569
    570
    571
    572
    573
    574
    575
    576
    577
    578
    579
    580
    581
    582
    583
    584
    585
    586
    587
    588
    589
    590
    591
    592
    593
    594
    595
    596
    597
    598
    599
    600
    601
    602
    603
    604
    605
    606
    607
    608
    609
    610
    611
    612
    613
    614
    615
    616
    617
    618
    619
    620
    621
    622
    623
    624
    625
    626
    627
    628
    629
    630
    631
    632
    633
    634
    635
    636
    637
    638
    639
    640
    641
    642
    643
    644
    645
    646
    647
    648
    649
    650
    651
    652
    653
    654
    655
    656
    657
    658
    659

    3×
    3×

    3×

    3×

    1×

    2546×

    15×

    15×
    24×

    1273×

    1273×

    1273×

    1273×

    1273×

    1×

    1×

    1269×
    1242×
    1242×

    1269×

    1269×

    1269×

    1269×

    1269×

    1269×

    1269×
    3×

    3×

    3×

    1266×

    1266×
    1266×

    1266×

    1266×

    1×

    1274×
    2×
    2×

    1274×
    1274×

    1274×

    1274×
    1×

    1273×
    15×

    15×
    3×

    1270×
    1270×

    1270×

    1×

    6×
    1×
    1×

    6×

    6×

    6×

    6×

    6×

    6×
    6×

    6×

    6×

    1×

    4×
    4×
    4×

    4×

    4×
    4×

    4×
    4×

    4×
    4×

    4×

    4×

    4×

    4×

    1×
    1266×

    1×
    170×

    1×

    1272×
    119×

    119×
    86×

    1272×

    1×

    1195×

    1195×

    1×
    2247×

    1×
    2×

    1×

    1267×

    1267×

    1267×

    1267×

    1267×

    1267×

    1267×

    1×
    10×

    1×

    1268×
    1268×

    1268×
    1267×

    1×

    1×

    1×

    1273×
    1273×
    1273×

    1273×

    1273×

    1273×

    1273×
    1266×

    1×
    5101×

    1×

    1273×

    1273×

    1273×

    1×
    1273×

    1273×

    1×

    1×

    1273×

    1273×

    1273×

    1273×

    1273×

     /**
     * The code in the <project-logo></project-logo> area
     * must not be changed.
     *
     * @see http://bpmn.io/license for more information.
     */
    import {
      assign,
      find,
      isFunction,
      isNumber,
      omit
    } from 'min-dash';

    import {
      domify,
      query as domQuery,
      remove as domRemove
    } from 'min-dom';

    import {
      innerSVG
    } from 'tiny-svg';

    import Diagram from 'diagram-js';
    import BpmnModdle from 'bpmn-moddle';

    import inherits from 'inherits';

    import {
      importBpmnDiagram
    } from './import/Importer';

    import CoreModule from './core';
    import TranslateModule from 'diagram-js/lib/i18n/translate';
    import SelectionModule from 'diagram-js/lib/features/selection';
    import OverlaysModule from 'diagram-js/lib/features/overlays';

    function checkValidationError(err) {

      // check if we can help the user by indicating wrong BPMN 2.0 xml
      // (in case he or the exporting tool did not get that right)

      var pattern = /unparsable content <([^>]+)> detected([\s\S]*)$/;
      var match = pattern.exec(err.message);

      Iif (match) {
        err.message =
          'unparsable content <' + match[1] + '> detected; ' +
          'this may indicate an invalid BPMN 2.0 diagram file' + match[2];
      }

      return err;
    }

    var DEFAULT_OPTIONS = {
      width: '100%',
      height: '100%',
      position: 'relative'
    };

    /**
     * Ensure the passed argument is a proper unit (defaulting to px)
     */
    function ensureUnit(val) {
      return val + (isNumber(val) ? 'px' : '');
    }

    /**
     * Find BPMNDiagram in definitions by ID
     *
     * @param {ModdleElement<Definitions>} definitions
     * @param {String} diagramId
     *
     * @return {ModdleElement<BPMNDiagram>|null}
     */
    function findBPMNDiagram(definitions, diagramId) {
      Iif (!diagramId) {
        return null;
      }

      return find(definitions.diagrams, function(element) {
        return element.id === diagramId;
      }) || null;
    }

    /**
     * A viewer for BPMN 2.0 diagrams.
     *
     * Have a look at {@link NavigatedViewer} or {@link Modeler} for bundles that include
     * additional features.
     *
     *
     * ## Extending the Viewer
     *
     * In order to extend the viewer pass extension modules to bootstrap via the
     * `additionalModules` option. An extension module is an object that exposes
     * named services.
     *
     * The following example depicts the integration of a simple
     * logging component that integrates with interaction events:
     *
     *
     * ```javascript
     *
     * // logging component
     * function InteractionLogger(eventBus) {
     *   eventBus.on('element.hover', function(event) {
     *     console.log()
     *   })
     * }
     *
     * InteractionLogger.$inject = [ 'eventBus' ]; // minification save
     *
     * // extension module
     * var extensionModule = {
     *   __init__: [ 'interactionLogger' ],
     *   interactionLogger: [ 'type', InteractionLogger ]
     * };
     *
     * // extend the viewer
     * var bpmnViewer = new Viewer({ additionalModules: [ extensionModule ] });
     * bpmnViewer.importXML(...);
     * ```
     *
     * @param {Object} [options] configuration options to pass to the viewer
     * @param {DOMElement} [options.container] the container to render the viewer in, defaults to body.
     * @param {String|Number} [options.width] the width of the viewer
     * @param {String|Number} [options.height] the height of the viewer
     * @param {Object} [options.moddleExtensions] extension packages to provide
     * @param {Array<didi.Module>} [options.modules] a list of modules to override the default modules
     * @param {Array<didi.Module>} [options.additionalModules] a list of modules to use with the default modules
     */
    export default function Viewer(options) {

      options = assign({}, DEFAULT_OPTIONS, options);

      this._moddle = this._createModdle(options);

      this._container = this._createContainer(options);

      /* <project-logo> */

      addProjectLogo(this._container);

      /* </project-logo> */

      this._init(this._container, this._moddle, options);
    }

    inherits(Viewer, Diagram);

    /**
     * Parse and render a BPMN 2.0 diagram.
     *
     * Once finished the viewer reports back the result to the
     * provided callback function with (err, warnings).
     *
     * ## Life-Cycle Events
     *
     * During import the viewer will fire life-cycle events:
     *
     *   * import.parse.start (about to read model from xml)
     *   * import.parse.complete (model read; may have worked or not)
     *   * import.render.start (graphical import start)
     *   * import.render.complete (graphical import finished)
     *   * import.done (everything done)
     *
     * You can use these events to hook into the life-cycle.
     *
     * @param {String} xml the BPMN 2.0 xml
     * @param {ModdleElement<BPMNDiagram>|String} [bpmnDiagram] BPMN diagram or id of diagram to render (if not provided, the first one will be rendered)
     * @param {Function} [done] invoked with (err, warnings=[])
     */
    Viewer.prototype.importXML = function(xml, bpmnDiagram, done) {

      if (isFunction(bpmnDiagram)) {
        done = bpmnDiagram;
        bpmnDiagram = null;
      }

      // done is optional
      done = done || function() {};

      var self = this;

      // hook in pre-parse listeners +
      // allow xml manipulation
      xml = this._emit('import.parse.start', { xml: xml }) || xml;

      this._moddle.fromXML(xml, 'bpmn:Definitions', function(err, definitions, context) {

        // hook in post parse listeners +
        // allow definitions manipulation
        definitions = self._emit('import.parse.complete', {
          error: err,
          definitions: definitions,
          context: context
        }) || definitions;

        var parseWarnings = context.warnings;

        if (err) {
          err = checkValidationError(err);

          self._emit('import.done', { error: err, warnings: parseWarnings });

          return done(err, parseWarnings);
        }

        self._setDefinitions(definitions);

        self.open(bpmnDiagram, function(err, importWarnings) {
          var allWarnings = [].concat(parseWarnings, importWarnings || []);

          self._emit('import.done', { error: err, warnings: allWarnings });

          done(err, allWarnings);
        });
      });
    };

    /**
     * Open diagram of previously imported XML.
     *
     * Once finished the viewer reports back the result to the
     * provided callback function with (err, warnings).
     *
     * ## Life-Cycle Events
     *
     * During switch the viewer will fire life-cycle events:
     *
     *   * import.render.start (graphical import start)
     *   * import.render.complete (graphical import finished)
     *
     * You can use these events to hook into the life-cycle.
     *
     * @param {String|ModdleElement<BPMNDiagram>} [bpmnDiagramOrId] id or the diagram to open
     * @param {Function} [done] invoked with (err, warnings=[])
     */
    Viewer.prototype.open = function(bpmnDiagramOrId, done) {

      if (isFunction(bpmnDiagramOrId)) {
        done = bpmnDiagramOrId;
        bpmnDiagramOrId = null;
      }

      var definitions = this._definitions;
      var bpmnDiagram = bpmnDiagramOrId;

      // done is optional
      done = done || function() {};

      if (!definitions) {
        return done(new Error('no XML imported'));
      }

      if (typeof bpmnDiagramOrId === 'string') {
        bpmnDiagram = findBPMNDiagram(definitions, bpmnDiagramOrId);

        if (!bpmnDiagram) {
          return done(new Error('BPMNDiagram <' + bpmnDiagramOrId + '> not found'));
        }
      }

      // clear existing rendered diagram
      // catch synchronous exceptions during #clear()
      try {
        this.clear();
      } catch (error) {
        return done(error);
      }

      // perform graphical import
      return importBpmnDiagram(this, definitions, bpmnDiagram, done);
    };

    /**
     * Export the currently displayed BPMN 2.0 diagram as
     * a BPMN 2.0 XML document.
     *
     * ## Life-Cycle Events
     *
     * During XML saving the viewer will fire life-cycle events:
     *
     *   * saveXML.start (before serialization)
     *   * saveXML.serialized (after xml generation)
     *   * saveXML.done (everything done)
     *
     * You can use these events to hook into the life-cycle.
     *
     * @param {Object} [options] export options
     * @param {Boolean} [options.format=false] output formated XML
     * @param {Boolean} [options.preamble=true] output preamble
     *
     * @param {Function} done invoked with (err, xml)
     */
    Viewer.prototype.saveXML = function(options, done) {

      if (!done) {
        done = options;
        options = {};
      }

      var self = this;

      var definitions = this._definitions;

      Iif (!definitions) {
        return done(new Error('no definitions loaded'));
      }

      // allow to fiddle around with definitions
      definitions = this._emit('saveXML.start', {
        definitions: definitions
      }) || definitions;

      this._moddle.toXML(definitions, options, function(err, xml) {

        try {
          xml = self._emit('saveXML.serialized', {
            error: err,
            xml: xml
          }) || xml;

          self._emit('saveXML.done', {
            error: err,
            xml: xml
          });
        } catch (e) {
          console.error('error in saveXML life-cycle listener', e);
        }

        done(err, xml);
      });
    };

    /**
     * Export the currently displayed BPMN 2.0 diagram as
     * an SVG image.
     *
     * ## Life-Cycle Events
     *
     * During SVG saving the viewer will fire life-cycle events:
     *
     *   * saveSVG.start (before serialization)
     *   * saveSVG.done (everything done)
     *
     * You can use these events to hook into the life-cycle.
     *
     * @param {Object} [options]
     * @param {Function} done invoked with (err, svgStr)
     */
    Viewer.prototype.saveSVG = function(options, done) {

      Eif (!done) {
        done = options;
        options = {};
      }

      this._emit('saveSVG.start');

      var svg, err;

      try {
        var canvas = this.get('canvas');

        var contentNode = canvas.getDefaultLayer(),
            defsNode = domQuery('defs', canvas._svg);

        var contents = innerSVG(contentNode),
            defs = defsNode ? '<defs>' + innerSVG(defsNode) + '</defs>' : '';

        var bbox = contentNode.getBBox();

        svg =
          '<?xml version="1.0" encoding="utf-8"?>\n' +
          '<!-- created with bpmn-js / http://bpmn.io -->\n' +
          '<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">\n' +
          '<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" ' +
               'width="' + bbox.width + '" height="' + bbox.height + '" ' +
               'viewBox="' + bbox.x + ' ' + bbox.y + ' ' + bbox.width + ' ' + bbox.height + '" version="1.1">' +
            defs + contents +
          '</svg>';
      } catch (e) {
        err = e;
      }

      this._emit('saveSVG.done', {
        error: err,
        svg: svg
      });

      done(err, svg);
    };

    /**
     * Get a named diagram service.
     *
     * @example
     *
     * var elementRegistry = viewer.get('elementRegistry');
     * var startEventShape = elementRegistry.get('StartEvent_1');
     *
     * @param {String} name
     *
     * @return {Object} diagram service instance
     *
     * @method Viewer#get
     */

    /**
     * Invoke a function in the context of this viewer.
     *
     * @example
     *
     * viewer.invoke(function(elementRegistry) {
     *   var startEventShape = elementRegistry.get('StartEvent_1');
     * });
     *
     * @param {Function} fn to be invoked
     *
     * @return {Object} the functions return value
     *
     * @method Viewer#invoke
     */

    Viewer.prototype._setDefinitions = function(definitions) {
      this._definitions = definitions;
    };

    Viewer.prototype.getModules = function() {
      return this._modules;
    };

    /**
     * Remove all drawn elements from the viewer.
     *
     * After calling this method the viewer can still
     * be reused for opening another diagram.
     *
     * @method Viewer#clear
     */
    Viewer.prototype.clear = function() {

      // remove businessObject#di binding
      //
      // this is necessary, as we establish the bindings
      // in the BpmnTreeWalker (and assume none are given
      // on reimport)
      this.get('elementRegistry').forEach(function(element) {
        var bo = element.businessObject;

        if (bo && bo.di) {
          delete bo.di;
        }
      });

      // remove drawn elements
      Diagram.prototype.clear.call(this);
    };

    /**
     * Destroy the viewer instance and remove all its
     * remainders from the document tree.
     */
    Viewer.prototype.destroy = function() {

      // diagram destroy
      Diagram.prototype.destroy.call(this);

      // dom detach
      domRemove(this._container);
    };

    /**
     * Register an event listener
     *
     * Remove a previously added listener via {@link #off(event, callback)}.
     *
     * @param {String} event
     * @param {Number} [priority]
     * @param {Function} callback
     * @param {Object} [that]
     */
    Viewer.prototype.on = function(event, priority, callback, target) {
      return this.get('eventBus').on(event, priority, callback, target);
    };

    /**
     * De-register an event listener
     *
     * @param {String} event
     * @param {Function} callback
     */
    Viewer.prototype.off = function(event, callback) {
      this.get('eventBus').off(event, callback);
    };

    Viewer.prototype.attachTo = function(parentNode) {

      Iif (!parentNode) {
        throw new Error('parentNode required');
      }

      // ensure we detach from the
      // previous, old parent
      this.detach();

      // unwrap jQuery if provided
      Iif (parentNode.get && parentNode.constructor.prototype.jquery) {
        parentNode = parentNode.get(0);
      }

      Iif (typeof parentNode === 'string') {
        parentNode = domQuery(parentNode);
      }

      parentNode.appendChild(this._container);

      this._emit('attach', {});

      this.get('canvas').resized();
    };

    Viewer.prototype.getDefinitions = function() {
      return this._definitions;
    };

    Viewer.prototype.detach = function() {

      var container = this._container,
          parentNode = container.parentNode;

      if (!parentNode) {
        return;
      }

      this._emit('detach', {});

      parentNode.removeChild(container);
    };

    Viewer.prototype._init = function(container, moddle, options) {

      var baseModules = options.modules || this.getModules(),
          additionalModules = options.additionalModules || [],
          staticModules = [
            {
              bpmnjs: [ 'value', this ],
              moddle: [ 'value', moddle ]
            }
          ];

      var diagramModules = [].concat(staticModules, baseModules, additionalModules);

      var diagramOptions = assign(omit(options, [ 'additionalModules' ]), {
        canvas: assign({}, options.canvas, { container: container }),
        modules: diagramModules
      });

      // invoke diagram constructor
      Diagram.call(this, diagramOptions);

      if (options && options.container) {
        this.attachTo(options.container);
      }
    };

    /**
     * Emit an event on the underlying {@link EventBus}
     *
     * @param  {String} type
     * @param  {Object} event
     *
     * @return {Object} event processing result (if any)
     */
    Viewer.prototype._emit = function(type, event) {
      return this.get('eventBus').fire(type, event);
    };

    Viewer.prototype._createContainer = function(options) {

      var container = domify('<div class="bjs-container"></div>');

      assign(container.style, {
        width: ensureUnit(options.width),
        height: ensureUnit(options.height),
        position: options.position
      });

      return container;
    };

    Viewer.prototype._createModdle = function(options) {
      var moddleOptions = assign({}, this._moddleExtensions, options.moddleExtensions);

      return new BpmnModdle(moddleOptions);
    };

    // modules the viewer is composed of
    Viewer.prototype._modules = [
      CoreModule,
      TranslateModule,
      SelectionModule,
      OverlaysModule
    ];

    // default moddle extensions the viewer is composed of
    Viewer.prototype._moddleExtensions = {};

    /* <project-logo> */

    import {
      open as openPoweredBy,
      BPMNIO_IMG
    } from './util/PoweredByUtil';

    import {
      event as domEvent
    } from 'min-dom';

    /**
     * Adds the project logo to the diagram container as
     * required by the bpmn.io license.
     *
     * @see http://bpmn.io/license
     *
     * @param {Element} container
     */
    function addProjectLogo(container) {
      var img = BPMNIO_IMG;

      var linkMarkup =
        '<a href="http://bpmn.io" ' +
           'target="_blank" ' +
           'class="bjs-powered-by" ' +
           'title="Powered by bpmn.io" ' +
           'style="position: absolute; bottom: 15px; right: 15px; z-index: 100">' +
          img +
        '</a>';

      var linkElement = domify(linkMarkup);

      container.appendChild(linkElement);

      domEvent.bind(linkElement, 'click', function(event) {
        openPoweredBy();

        event.preventDefault();
      });
    }

    /* </project-logo> */